config/routes.rb
Rails.application.routes.draw do
  devise_for :admin_users, ActiveAdmin::Devise.config
  ActiveAdmin.routes(self)

  namespace :api do
    resources :conferences, :defaults => { :format => 'json' }
    resources :events, :defaults => { :format => 'json' } do
      collection do
        post 'update_promoted'
        post 'update_view_counts'
      end
    end
    resources :recordings, :defaults => { :format => 'json' }
    resources :news, :defaults => { :format => 'json' }
  end

  namespace :public do
    get :index, path: '/', defaults: { format: 'json' }
    get :oembed
    resources :conferences, only: [:index, :show], defaults: { format: 'json' }
    resources :events, only: %i(index show), defaults: { format: 'json' } do
      get :search, defaults: { format: 'json' }, on: :collection
    end
    resources :recordings, only: %i(index show), defaults: { format: 'json' } do
      collection do
        post 'count'
      end
    end
  end

  scope module: 'frontend' do
    root to: 'home#index'
    if Rails.env.production?
      get '404', to: 'home#page_not_found'
    end
    get '/about', to: 'home#about'
    get '/search', to: 'search#index'
    get '/sitemap.xml', to: 'sitemap#index', defaults: { format: 'xml' }

    get '/v/:slug', to: 'events#show', as: :event, :constraints => { slug: %r'[^/]+' }
    get '/postroll/:slug', to: 'events#postroll', as: :postroll, :constraints => { slug: %r'[^/]+' }
    get '/v/:slug/oembed', to: 'events#oembed', as: :oembed_event, :constraints => { slug: %r'[^/]+' }

    get '/c/:acronym', to: 'conferences#show', as: :conference

    get '/b', to: 'conferences#browse', as: :browse_start
    get '/b/*slug', to: 'conferences#browse', as: :browse

    get '/recent', to: 'recent#index'
    get '/popular', to: 'popular#index'

    get '/tags/:tag', to: 'tags#show', as: :tag

    get '/news.atom', to: 'news#index', defaults: { format: 'xml' }, as: :news
    get '/updates.rdf', to: 'feeds#updates', defaults: { format: 'xml' }
    get '/podcast-audio-only.xml', to: 'feeds#podcast_audio', defaults: { format: 'xml' }

    get '/podcast-(:quality).xml', to: 'feeds#podcast',
        defaults: { format: 'xml' }, :constraints => { quality: %r'\w\w' }
    get '/podcast-archive-(:quality).xml', to: 'feeds#podcast_archive',
        defaults: { format: 'xml' }, :constraints => { quality: %r'\w\w' }

    get '/c/:acronym/podcast/:mime_type-(:quality).xml', to: 'feeds#podcast_folder',
        defaults: { format: 'xml' }, :constraints => { quality: %r'\w\w' }, as: :podcast_folder_video_feed
    get '/c/:acronym/podcast/:mime_type-master.xml', to: 'feeds#podcast_folder',
        defaults: { format: 'xml', quality: 'master' }, as: :podcast_folder_video_master_feed
    get '/c/:acronym/podcast/:mime_type.xml', to: 'feeds#podcast_folder',
        defaults: { format: 'xml' }, :constraints => { quality: %r'\w\w' }, as: :podcast_folder_feed

    get '/podcast/:slug/:mime_type', to: 'feeds#podcast_folder', defaults: { format: 'xml' }, as: :old_podcast_folder_feed
    get '/podcast.xml', to: 'feeds#podcast_legacy', defaults: { format: 'xml' }
    get '/podcast-archive.xml', to: 'feeds#podcast_archive_legacy', defaults: { format: 'xml' }
  end
end

app/models/frontend/conference.rb
module Frontend
  class Conference < ::Conference
    has_many :events, class_name: 'Frontend::Event'
    has_many :recordings, through: :events

    scope :with_events, ->() {
      where('event_last_released_at IS NOT NULL')
    }
    scope :with_recent_events, ->() {
      where('event_last_released_at IS NOT NULL')
        .order('event_last_released_at DESC')
    }
    scope :with_events_newer, ->(date) {
      where('event_last_released_at IS NOT NULL')
        .order('event_last_released_at DESC')
        .where('event_last_released_at > ?', date)
    }
    scope :with_events_older, ->(date) {
      where('event_last_released_at IS NOT NULL')
        .order('event_last_released_at DESC')
        .where('event_last_released_at < ?', date)
    }

    def self.has_live?
      Conference.where('streaming ? :key', key: 'groups').any?
    end

    def self.first_live
      Conference.where('streaming ? :key', key: 'groups').first
    end

    def self.live
      conferences = Conference.where('streaming ? :key', key: 'groups')
      groups = conferences.map { |c| c.streaming['groups'].first }.compact
      groups.map { |g| g['rooms'] }.flatten
    end

    def mime_types
      return enum_for(:mime_types) unless block_given?
      recordings.pluck(:mime_type).uniq.map { |mime_type|
        yield mime_type.freeze, MimeType.mime_type_slug(mime_type)
      }
    end

    def recordings_url
      File.join(Settings.cdn_url, recordings_path).freeze
    end
  end
end

app/models/frontend/news.rb
module Frontend
  class News < ::News
    scope :recent, ->(n) { order('date desc').limit(n) }

    def date_formatted
      date.strftime('%d.%m.%Y')
    end
  end
end

app/models/frontend/recording.rb
module Frontend
  class Recording < ::Recording
    belongs_to :event, class_name: 'Frontend::Event'
    scope :by_mime_type, ->(mime_type) { where(mime_type: mime_type) }

    def url
      File.join(event.conference.recordings_url, folder || '', filename).freeze
    end

    def cors_url
      File.join(Settings.cors_url, event.conference.recordings_path, folder || '', filename).freeze
    end

    def resolution
      return '' unless height
      if height < 720
        'sd'
      elsif height < 1080
        'hd'
      elsif height < 1716
        'full-hd'
      else
        '4k'
      end
    end

    def filetype
      MimeType.humanized_mime_type(mime_type)
    end
  end
end

app/controllers/frontend/conferences_controller.rb
module Frontend
  class ConferencesController < FrontendController
    SORT_PARAM = {
      'name' => 'title',
      'duration' => 'duration',
      'date' => 'date desc, release_date desc',
      'view_count' => 'view_count desc'
    }.freeze

    before_action :check_sort_param, only: %w(show)

    def browse
      return show if slug_matches_conference

      @folders = conferences_folder_tree_at(params[:slug] || '')
      return redirect_to root_url if @folders.blank?
      respond_to do |format|
        format.html { render :browse }
      end
    end

    def show
      @conference = Frontend::Conference.find_by!(acronym: params[:acronym]) unless @conference
      @events = @conference.events.includes(:conference).order(sort_param)
      respond_to do |format|
        format.html { render :show }
      end
    end

    private

    def slug_matches_conference
      @conference = Frontend::Conference.find_by(slug: params[:slug])
    end

    def conferences_folder_tree_at(path)
      tree = FolderTree.new
      tree.build(conferences_with_events)
      folders = tree.folders_at(path)
      fail ActiveRecord::RecordNotFound unless folders
      tree.sort_folders(folders)
    end

    def conferences_with_events
      Conference.where('downloaded_events_count > 0').pluck(:id, :slug)
    end

    def sort_param
      return SORT_PARAM[@sorting] if @sorting
      'view_count desc'
    end

    def check_sort_param
      return unless params[:sort]
      return unless SORT_PARAM.keys.include?(params[:sort])
      @sorting = params[:sort]
    end
  end
end

app/controllers/frontend/events_controller.rb
module Frontend
  class EventsController < FrontendController
    before_action :load_event

    def show
      respond_to { |format| format.html }
    end

    def postroll
      @events = related_events(3)
      render layout: false
    end

    # videoplayer suitable for embedding in an iframe
    def oembed
      @width = params[:width] || view_context.aspect_ratio_width
      @height = params[:height] || view_context.aspect_ratio_height
      response.headers.delete 'X-Frame-Options'
      render layout: 'frontend/oembed'
    end

    private

    def related_events(n)
      return Event.find(@event.related_event_ids(n)) if @event.metadata['related'].present?
      @event.next_from_conference(n)
    end

    def load_event
      @event = Frontend::Event.find_by!(slug: params[:slug])
      @conference = @event.conference
      @player = ''
      if params[:player]
        # TODO input sanitation/validation?
        @player = '_' + params[:player]
      end
    end
  end
end

app/controllers/frontend/home_controller.rb
module Frontend
  class HomeController < FrontendController
    helper_method :recent_events_for_conference

    def index
      @news = Frontend::News.recent(1).first()
      @hours_count = Frontend::Event.sum(:duration)/(60*60)
      @recordings_count = Frontend::Recording.count
      @events_count = Frontend::Event.count
      @conferences_count = Frontend::Conference.count

      @conference_limit = 3
      @events_limit = 3

      @recent_conferences = Frontend::Conference.with_recent_events().limit(@conference_limit)

      respond_to { |format| format.html }
    end

    def page_not_found
      respond_to do |format|
        format.json { head :no_content }
        format.xml { render xml: { status: :error } }
        format.all { render :page_not_found, status: 404 }
      end
    end

    private

    def recent_events_for_conference(conference)
      conference.events.order('release_date DESC, id DESC').limit(@events_limit)
    end
  end
end

app/controllers/frontend/news_controller.rb
module Frontend
  class NewsController < FrontendController
    def index
      news = News.latest_first
      atom_feed = Feeds::NewsFeedGenerator.generate(news,
        options: {
          author: Settings.feeds['channel_owner'],
          title: I18n.t('custom.news_title'),
          feed_url: news_url,
          icon: File.join(Settings.frontend_url, 'favicon.ico'),
          logo: view_context.image_url('frontend/voctocat.svg')
        })
      respond_to do |format|
        format.xml { render xml: atom_feed }
      end
    end
  end
end

app/controllers/frontend/popular_controller.rb
module Frontend
  class PopularController < FrontendController
    def index
      @events = Frontend::Event.order('view_count DESC').limit(20).includes(:conference)

      respond_to { |format| format.html }
    end

  end
end

app/controllers/frontend/recent_controller.rb
module Frontend
  class RecentController < FrontendController
    def index
      @events = Frontend::Event.recent(20).includes(:conference)

      respond_to { |format| format.html }
    end

  end
end

app/controllers/frontend/search_controller.rb
module Frontend
  class SearchController < FrontendController
    def index
      @searchquery = params[:q]
      @events = Frontend::Event.query(params[:q]).page(params[:page]).records
      respond_to { |format| format.html }
    end
  end
end

app/controllers/frontend/sitemap_controller.rb
module Frontend
  class SitemapController < FrontendController
    def index
      @base_url = Settings.frontend_url
      respond_to { |format| format.xml }
    end
  end
end

app/controllers/frontend/tags_controller.rb
module Frontend
  class TagsController < FrontendController
    def show
      @tag = params[:tag]
      raise ActiveRecord::RecordNotFound unless @tag
      # TODO native postgresql query?
      @events = Frontend::Event.all.select { |event| event.tags.include? @tag }
      respond_to { |format| format.html }
    end
  end
end

app/controllers/frontend_controller.rb
class FrontendController < ActionController::Base
  layout 'frontend/frontend'
end

app/helpers/frontend/application_helper.rb
module Frontend
  module ApplicationHelper
    require 'uri'

    def recording_quality(recording)
      recording.high_quality ? 'high' : 'low'
    end

    def recording_title(recording)
      if recording.slides?
        "slides #{recording.language} #{recording.height}p"
      else 
        "#{recording.language} #{recording.height}p"
      end
    end

    def oembed_api_event_url(event)
      (public_oembed_url(url: event_url(slug: event.slug))).freeze
    end

    def twitter_url(title, url)
      'https://twitter.com/home?status='.freeze + URI.encode_www_form_component(title + ': ' + url)
    end

    def facebook_url(title, url)
      'https://www.facebook.com/sharer/sharer.php?t='.freeze + URI.encode_www_form_component(title) + '&u=' + URI.encode_www_form_component(url)
    end

    def googleplus_url(title, url)
      'https://plus.google.com/share?title='.freeze + URI.encode_www_form_component(title) + '&url=' + URI.encode_www_form_component(url)
    end

    def appnet_url(title, url)
      'https://alpha.app.net/intent/post?text='.freeze + URI.encode_www_form_component(title + ': ' + url)
    end

    def diaspora_url(title, url)
      'https://share.diasporafoundation.org/?title='.freeze + URI.encode_www_form_component(title).gsub(/\+/, '%20') + '&url=' + URI.encode_www_form_component(url)
    end

    def mail_url(title, url)
      content = ERB::Util.url_encode(title + ': ' + url)
      subject = ERB::Util.url_encode(title)
      URI::MailTo.build(['', [['subject', subject], ['body', content]]]).to_s.freeze
    end

    def breadcrumbs_trail
      path = if @conference
               @conference.slug
             elsif @folders
               @folders.last.parent_path
             else
               ''.freeze
             end
      parts = path.split('/')
      return if parts.blank?
      #TODO -> use title instead of 'event'
      parts += ['event'] if @event
      current = parts.pop
      yield parts.map!(&:freeze), current.freeze
    end

    # TODO which video to prefer?
    def opengraph_video(recordings)
      recordings.first.try(:url)
    end

    def keywords
      if @event && @event.tags
        [@event.tags, I18n.t('custom.header.keywords')].join(', ')
      else
        I18n.t('custom.header.keywords')
      end
    end

    def duration_in_minutes(duration)
      "#{duration / 60} min" if duration > 0
    end

    def video_for_flash(recordings)
      url = recordings.find { |recording| recording.mime_type == 'video/mp4' }.try(:url)
      if url.present?
        h(url)
      elsif recordings.present?
        h(recordings.first.url)
      else
        # :(
        ''
      end
    end

    def aspect_ratio_width(high = true)
      case @conference.aspect_ratio
      when /16:9/
        high ? '640' : '188'
      when /4:3/
        high ? '400' : '120'
      end
    end

    def aspect_ratio_height(high = true)
      case @conference.aspect_ratio
      when /16:9/
        high ? '360' : '144'
      when /4:3/
        high ? '300' : '90'
      end
    end

    def parse_url_host(_urlish)
      URI.parse(@event.link).host
    rescue URI::InvalidURIError
      return ''.freeze
    end

    def persons_icon(persons)
      if persons.length <= 1
        'icon-user-light'.freeze
      else
        'icon-users-light'.freeze
      end
    end

    def display_release_date_title(event)
      return 'event and release date' if event.released_on_event_day?
      return 'event date' if event.date
      'video release date'
    end
  end
end

app/helpers/frontend/event_recording_filter.rb
module Frontend
  class EventRecordingFilter
    def self.by_quality_string(quality)
      if quality.nil? || quality.empty?
        return EventRecordingFilter.new
      end

      return FeedQuality.eventRecordingFilter(quality)
    end

    @target_mime_type = nil

    def with_mime_type(mime_type)
      @target_mime_type = mime_type
      self
    end

    def filter(event)
      if @target_mime_type
        @recordings = event.recordings.by_mime_type(@target_mime_type)
      else
        @recordings = event.recordings.video
      end

      @recordings = filter_by_quality(@recordings)

      return if @recordings.empty?

      if @target_mime_type != nil
        @recordings.first.freeze
      else
        select_first_video_with_preferred_mime_type().freeze
      end
    end

    private

    def filter_by_quality(recordings)
      recordings
    end

    def select_first_video_with_preferred_mime_type()
      MimeType::PREFERRED_VIDEO.each { |mime_type|
        found = @recordings.find { |recording| recording.mime_type == mime_type }
        return found if found != nil
      }
      @recordings.first
    end
  end
end

app/helpers/frontend/event_recording_filter_high_quality.rb
module Frontend
  class EventRecordingFilterHighQuality < EventRecordingFilter
    def filter_by_quality(recordings)
      recordings.sort {
          |recording_a,recording_b| recording_b.number_of_pixels - recording_a.number_of_pixels
      }
    end
  end
end

app/helpers/frontend/event_recording_filter_low_quality.rb
module Frontend
  class EventRecordingFilterLowQuality < EventRecordingFilter
    def filter_by_quality(recordings)
      recordings
        .select { |recording| recording.height && recording.height.to_i < 720 }
        .sort { |recording_a,recording_b| recording_b.number_of_pixels - recording_a.number_of_pixels }
    end
  end
end

app/helpers/frontend/event_recording_filter_master.rb
module Frontend
  class EventRecordingFilterMaster < EventRecordingFilter
    def filter_by_quality(recordings)
      recordings
        .sort { |recording_a,recording_b| recording_b.number_of_pixels - recording_a.number_of_pixels }
        .sort { |recording_a,recording_b| recording_b.language.length - recording_b.language.length }
        .select { |recording| recording.slides? != true }
    end
  end
end

app/views/frontend/shared/_event_metadata.haml
.caption
  %h3
    %a{href: event_path(slug: event.slug)}
      = truncate(event.title, length: 90, separator: ' ', omission: '…')

  - if event.subtitle.present?
    %h4{title: event.subtitle}
      = truncate(event.subtitle, length: 60, separator: ' ', omission: '…')

  %ul.metadata
    %li.duration
      %span.icon.icon-clock-o
      = duration_in_minutes(event.duration)
    %li.date
      %span.icon.icon-calendar-o
      = event.display_date
    %li.view-count
      %span.icon.icon-eye
      = event.view_count
    %li.persons
      = render partial: 'frontend/shared/event_persons', locals: { persons: event.persons }

app/views/frontend/shared/_event_persons.haml
- if not persons.empty?
  %span.icon{class: persons_icon(persons)}
  - persons.to_enum.with_index(1).each do |speaker, index|
    - if (persons.count - 1) == index
      - delimiter = ' and'
    - elsif persons.count != index
      - delimiter = ','

    = succeed delimiter do
      %a{href: search_path(q: speaker)}= speaker

app/views/frontend/shared/_event_thumb.haml
%a{href: event_path(slug: event.slug)}
  .duration-container
    %img.video-thumbnail{src: h(event.thumb_url), alt: h(event.title)}
    .duration
      %span.icon.icon-clock-o
      = duration_in_minutes(event.duration)

app/views/frontend/shared/_event_with_conference.html.haml
- cache([event.conference, event]) do
  .event-preview.has-conference
    = render partial: 'frontend/shared/event_thumb', locals: { event: event }
    = render partial: 'frontend/shared/event_metadata', locals: { event: event }
    .conference
      %a{href: conference_path(acronym: event.conference.acronym)}
        = event.conference.title

app/views/frontend/shared/_folder_feeds.haml
- conference.mime_types do |mime_type, mime_type_name|
  - if MimeType.is_video(mime_type)
    - feed_url = podcast_folder_video_feed_url(acronym: conference.acronym, mime_type: mime_type_name, quality: 'hq')
  - elsif MimeType.is_audio(mime_type)
    - feed_url = podcast_folder_feed_url(acronym: conference.acronym, mime_type: mime_type_name)
  %link{rel: "alternate", type: "application/rss+xml", title: "Podcast feed #{MimeType.humanized_mime_type(mime_type)} for this folder", href: feed_url}

app/views/frontend/shared/_footer.haml
%footer
  by 
  %a.inverted{href: '//freifunk.net/webteam'} freifunk.net Webteam

app/views/frontend/shared/_header.haml
%meta{'http-equiv' => 'X-UA-Compatible', content: 'IE=edge'}
%meta{'http-equiv' => 'Content-Type', content: 'text/html; charset=UTF-8'}
%meta{name: 'robots', content: 'index,follow'}
%meta{name: 'author', content: I18n.t('custom.header.author')}
- if content_for?(:description)
  = yield :description
- else
  %meta{name: 'description', content: I18n.t('custom.header.description')}
%meta{name: 'keywords', content: keywords}
%meta{name: 'google-site-verification', content: Settings.header['google']}
%meta{name: 'viewport', content: 'width=device-width, initial-scale=1.0'}

%link{rel: 'apple-touch-icon', sizes: '57x57', href: '/apple-touch-icon-57x57.png'}
%link{rel: 'apple-touch-icon', sizes: '72x72', href: '/apple-touch-icon-72x72.png'}
%link{rel: 'apple-touch-icon', sizes: '60x60', href: '/apple-touch-icon-60x60.png'}
%link{rel: 'apple-touch-icon', sizes: '76x76', href: '/apple-touch-icon-76x76.png'}
%link{rel: 'icon', type: 'image/png', href: '/favicon-96x96.png', sizes: '96x96'}
%link{rel: 'icon', type: 'image/png', href: '/favicon-16x16.png', sizes: '16x16'}
%link{rel: 'icon', type: 'image/png', href: '/favicon-32x32.png', sizes: '32x32'}

= stylesheet_link_tag 'application'
= javascript_include_tag 'application'

%link{rel: 'alternate', type: 'application/atom+xml', title: I18n.t('rss.title.atom'), href: '/news.atom'}
%link{rel: 'alternate', type: 'application/rss+xml', title: I18n.t('rss.title.last100'), href: '/updates.rdf'}
%link{rel: 'alternate', type: 'application/rss+xml', title: I18n.t('rss.title.last100'), href: '/podcast.xml'}
%link{rel: 'alternate', type: 'application/rss+xml', title: I18n.t('rss.title.podcast_archive'), href: '/podcast-archive.xml'}

app/views/frontend/shared/_live.html.haml
.promoted.themed-banner.live
  %h2= "Live now – " + Frontend::Conference.first_live.title
  .titlebar
  .slider
    - Frontend::Conference.live.each_with_index do |event, i|
      .slide
        %a.item{href: event['link'], 'class' => (i == 0 and 'active')}
          %img{src: h(event['thumb']), alt: event['display'], title: event['display']}

app/views/frontend/shared/_navbar.haml
.navbar.navbar-default.navbar-fixed-top(role="navigation")
  .container-fluid
    .navbar-header
      %a.navbar-brand(href='/')
        %span
          %img{src: image_path('frontend/voctocat.svg'), alt: 'media.ccc.de logo, a lucky cat holding a play icon'}
          media.freifunk.net

    - if content_for?(:navbar)
      = yield :navbar

    .nav.navbar-form.navbar-right.button-wrapper
      %a.form-control.btn.btn-default{href: '/about.html'}
        %span.icon.icon-info

    .nav.navbar-form.navbar-right.dropdown
      %button#feedMenu.btn.btn-default.dropdown-toggle{"aria-expanded" => "true", "aria-haspopup" => "true", "data-toggle" => "dropdown", :type => "button"}
        %span.icon.icon-rss
      %div.dropdown-menu.feeds_dropdown{"aria-labelledby" => "feedMenu"}
        = render 'frontend/shared/navbar_feeds', locals: { conference: @conference }

    %form.navbar-form.navbar-right{role: 'search', action: '/search/', method: 'get', id: 'media-search'}
      .form-group.input-group
        %input.form-control{type: 'search', size: '17', name: 'q', placeholder: 'Search…', value: @searchquery}
        %span.input-group-btn
          %button.btn.btn-default{type: 'submit'}
            %span.icon.icon-search

  %div#feedMenuMobile.feeds_dropdown{"aria-labelledby" => "feedMenu"}
    = render 'frontend/shared/navbar_feeds', locals: { conference: @conference }


- breadcrumbs_trail do |parts, last|
  .breadcrumb
    %ol.container-fluid.breadcrumb
      %li
        %a.inverted{href: browse_start_path}
          browse
      - parts.each_with_index do |part, index|
        %li
          %span.icon.icon-chevron-right
          %a.inverted{href: browse_path(parts[0..index].join('/'))}
            = part
      %li.active
        %span.icon.icon-chevron-right
        = last

app/views/frontend/shared/_player_audio.haml
%audio.audio{controls: 'controls', 'data-id' => event.id, preload: 'none'}
  - @event.recordings.audio.each do |recording|
    %source{type: recording.mime_type, src: h(recording.url), data: { lang: recording.language }}

    %p Your Browser can't play this Audio-File. Please download the File below and use a Desktop-Player.

:javascript
  $(function() { MirrorbrainFix.setupPlayer(); })

app/views/frontend/shared/_player_video.haml
<!-- Mediaelement Player -->

%video.video{controls: 'controls', 'data-id' => event.id, poster: event.poster_url, width: width, height: height}
  - event.videos_sorted_by_language.each do |recording|
    %source{type: recording.mime_type, src: h(recording.url), data: { lang: recording.language, quality: recording_quality(recording) }, title: recording_title(recording)}

  - event.recordings.subtitle.each do |track|
    %track{kind: "subtitles", src: h(track.cors_url), srclang: track.language_iso_639_1()}

  %link{rel: "postroll", href: postroll_path(slug: event.slug)}

  -# Flash fallback for browsers with flash, but without JavaScript… – to be deleted? --Andi
  %object{ width: width, height: height, type: 'application/x-shockwave-flash', data: asset_url('mediaelement-flash-video.swf') }
    %param{ name: 'allowFullScreen', value: 'true' }
    %param{ name: 'flashvars', value: "controls=true&file=#{video_for_flash(event.videos_sorted_by_language)}" }

    %p Your browser can't play this video file. Please download the file below and use a desktop player e.g. VLC.

:javascript
  $(function() {
    var stamp = window.location.hash.split('#t=')[1] || window.location.hash.split('&t=')[1],
        $video = $('video'),
        promises = [];

    $('video source').each(function() {
      var $source = $(this);
      // Prop always presents the fully resolved URL
      promises.push(
        MirrorbrainFix.selectMirror($source.prop('src'), function(mirror) {
        $source.attr('src', mirror);
      })
      );
    });

    $.when.apply($, promises).done(function() {
      $('video').mediaelementplayer({
        usePluginFullScreen: true,
        enableAutosize: true,
        stretching: '#{stretching}',
        features: ['skipback', 'playpause', 'jumpforward', 'progress', 'current', 'duration', 'tracks', 'volume', 'speed', 'sourcechooser', 'fullscreen', 'postroll'],
        skipBackInterval: 15,
        success: function (mediaElement) {
          mediaElement.addEventListener('canplay', function () {
            if(stamp) {
              mediaElement.setCurrentTime(stamp);
              stamp = null;
            }
          });
          mediaElement.addEventListener('playing', function () {
            $.post("/public/recordings/count", {event_id: $video.data('id'), src: mediaElement.src});
          }, false);
          mediaElement.addEventListener('pause', function() {
            var hash = '#t='+Math.round(mediaElement.currentTime);
            window.location.replaceHash(hash);
          }, false);
        }
      });
    });
  })

app/views/frontend/shared/_player_video_native.haml
<!-- Native HTML5 video element -->

%video.video{controls: 'controls', 'data-id' => event.id, poster: event.poster_url, width: width, height: height, preload: 'none', class: 'video-native'}
  - event.videos_sorted_by_language.each do |recording|
    %source{type: recording.mime_type, src: h(recording.url), data: { lang: recording.language, quality: recording_quality(recording) }, title: recording_title(recording)}

  - event.recordings.subtitle.each do |track|
    %track{kind: "subtitles", src: h(track.cors_url), srclang: track.language_iso_639_1()}

app/views/frontend/shared/_promoted.haml
.promoted.themed-banner
  .titlebar
  .slider
    - Frontend::Event.promoted(10).includes(:conference).each_with_index do |event, i|
      .slide
        %a.item{href: event_path(slug: event.slug), 'class' => (i == 0 and 'active')}
          %img{src: h(event.thumb_url), alt: event.title, title: event.short_title}

app/views/frontend/shared/_related.html.haml
.related
  .slider
    - events.each_with_index do |event, i|
      .slide
        %a.item{href: event_path(slug: event.slug), 'class' => (i == 0 and 'active')}
          %img{src: h(event.thumb_url), alt: event.title, title: event.short_title}